﻿/*****************************************************************************
*                                                                            *
*  XELF.OpenNI.Sample                                                        *
*  Copyright © 2010-2011 XELF                                                *
*  http://xelf.info/                                                         *
*                                                                            *
*  This file is part of XELF.OpenNI.Sample                                   *
*                                                                            *
*  XELF.OpenNI.Sample stays under a dual license: Ms-PL or LGPL              *
*                                                                            *
*  Please note that differences between XELF.OpenNI and XELF.OpenNI.Sample   *
*  in these licences.                                                        *
*                                                                            *
*****************************************************************************/

using Microsoft.Xna.Framework;

namespace XELF.MotionDesign {

	/// <summary>
	/// sample code: unfiltered 
	/// </summary>
	class PoseFilter {
		public Pose Output;

		int index;
		readonly Pose[] buffer = new Pose[1];

		public PoseFilter() {
			Clear();
		}
		void Clear() {
			index = 0;
			for (int i = 0; i < buffer.Length; i++) {
				buffer[i] = Pose.Identity;
			}
		}
		public void Input(Pose pose) {
			pose.Rotation.Normalize();
			if (pose.Rotation.W < 0) {
				Quaternion.Negate(ref pose.Rotation, out pose.Rotation);
			}
			buffer[index] = pose;
			if (++index >= buffer.Length) {
				index = 0;
			}

			Interpolate();
		}

		void Interpolate() {
			Output = buffer[0];
		}
	}

}
